devtools/mkarchroot

158 lines
4.1 KiB
Bash
Executable File

#!/bin/sh
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
FORCE="n"
RUN=""
working_dir=""
APPNAME=$(basename "${0}")
if [ "$EUID" != "0" ]; then
echo "This script must be run as root."
exit 1
fi
usage ()
{
echo "usage ${APPNAME} [options] working-dir package [package [package..]]"
echo " options:"
echo " -r <app> run 'app' within the context of the chroot"
echo " -f force overwrite of files in the working-dir"
echo " -h this message."
exit 1
}
while getopts 'r:fh' arg; do
case "${arg}" in
r) RUN="$OPTARG" ;;
f) FORCE="y" ;;
h|?) usage ;;
*) echo "invalid argument '${arg}'"; usage ;;
esac
done
shift $(($OPTIND - 1))
if [ "$RUN" == "" -a $# -lt 2 ]; then
echo "you must specify a directory and one or more packages"
usage
elif [ $# -lt 1 ]; then
echo "you must specify a directory"
usage
fi
working_dir="$(readlink -f ${1})"
shift 1
[ "${working_dir}" = "" ] && echo "error: please specify a working directory" && usage
# {{{ functions
function chroot_mount ()
{
echo "mounting sysfs : /sys"
[ -e "${working_dir}/sys" ] || mkdir "${working_dir}/sys"
mount -t sysfs sysfs "${working_dir}/sys"
echo "mounting procfs : /proc"
[ -e "${working_dir}/proc" ] || mkdir "${working_dir}/proc"
mount -t proc proc "${working_dir}/proc"
echo "binding device nodes : /dev"
[ -e "${working_dir}/dev" ] || mkdir "${working_dir}/dev"
mount -o bind /dev "${working_dir}/dev"
echo "binding pacman cache : /var/cache/pacman"
[ -e "${working_dir}/var/cache/pacman" ] || mkdir -p "${working_dir}/var/cache/pacman"
mount -o bind /var/cache/pacman "${working_dir}/var/cache/pacman"
trap 'chroot_umount' 0 1 2 15
}
function chroot_umount ()
{
echo "cleaning up mounts"
umount "${working_dir}/proc"
umount "${working_dir}/sys"
umount "${working_dir}/dev"
umount "${working_dir}/var/cache/pacman"
}
# }}}
if [ "$RUN" != "" ]; then
# run chroot {{{
if [ "$EUID" != "0" ]; then
echo "Running a chroot requires root privileges, aborting"
exit 1
fi
#Sanity check
if [ ! -f "${working_dir}/.arch-chroot" ]; then
echo "'${working_dir}' does not appear to be a Arch chroot"
echo " please build the image using mkarchchroot"
exit 1
fi
chroot_mount
echo "starting chroot ($RUN)"
chroot "${working_dir}" "${RUN}"
# }}}
else
# {{{ build chroot
if [ -e "${working_dir}" -a "${FORCE}" = "n" ]; then
echo "Working dir '${working_dir}' already exists - try using -f"
exit 1
fi
mkdir -p "${working_dir}"
chroot_mount
pacargs="--noconfirm -v " #--noprogressbar -v
pacargs="$pacargs --root=${working_dir}"
# pacman takes these as relative to the given root
pacargs="$pacargs --dbpath=/var/lib/pacman"
pacargs="$pacargs --cachedir=/var/cache/pacman/pkg"
if [ $# -eq 0 ]; then
echo "no packages to install"
else
echo "installing packages:"
for i in $@; do echo -e "\t$i"; done
op="-Sy"
if [ "$FORCE" == "y" ]; then
op="${op}f"
fi
if ! pacman ${op} ${pacargs} $@; then
echo "error: failed to instal all packages"
exit 1
fi
fi
if [ -d "${working_dir}/lib/modules" ]; then
echo "running ldconfig"
ldconfig -r "${working_dir}"
fi
echo "generating default locales"
sed -i "s|^#\(.*$LANG\)|\1|g" "${working_dir}/etc/locale.gen"
chroot "${working_dir}" locale-gen
if [ ! -e "${working_dir}/.arch-chroot" ]; then
date +%s > "${working_dir}/.arch-chroot"
fi
# }}}
fi
# vim:ft=sh:ts=4:sw=4:et: